/*
	Nu Jongg
	Code & Images: Piero Cioni for Red Omega Studio p.s.c.r.l.

	This Widget is a simple game.
	
	Visit our website at: <http://www.redomegastudio.com>

	(c) 2003 - 2005 Red Omega Studio p.s.c.r.l.
*/

var over = 0;
var layoutName = preferences.layout.value;
var setName = preferences.set.value;
var points = 0;
var hiScoreClassic = preferences.hiScoreClassicPref.value;
var hiScoreCastle = preferences.hiScoreCastlePref.value;
var hiScorePyramid = preferences.hiScorePyramidPref.value;
var hiScoreSquares = preferences.hiScoreSquaresPref.value;
var hiScoreOmega = preferences.hiScoreOmegaPref.value;
var hiScoreTowers = preferences.hiScoreTowersPref.value;
var hiScoreInfinite = preferences.hiScoreInfinitePref.value;
var hiScoreHouse = preferences.hiScoreHousePref.value;
var gamePaused = 1;
var gameStopped = 1;
var gameWaiting = 1;
var gamePiccolo = 0;
var i;
var r;
var gameMode = 0;
var tileSelected = 0;
var typeSelected = 0;
var totalTiles = 144;
var timeGame = 0;
var gameString = " game running";
var mi = new Array();
//if(system.platform != "windows")
//{
	mi[0] = new MenuItem();
	mi[0].title = "Start a new game";
	mi[0].enabled = true;
	mi[0].checked = false;
	mi[0].onSelect = "conditionalStartPlay();";
	mi[1] = new MenuItem();
	mi[1].title = "Hide";
	mi[1].checked = false;
	mi[1].onSelect = "switchPiccolo();";
	main_window.contextMenuItems = mi;
//}

var undoPenalty = 100;
var undoPointer = 0;
var hintPenalty = 100;
var undoOne = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
var undoTwo = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);

var tiledown = new Image();
tiledown.src = "Resources/Sets/"+setName+"/down.png";
tiledown.hOffset = 0;
tiledown.vOffset = 0;
tiledown.zOrder = 1000;
tiledown.opacity = 0;

var tilesel = new Image();
tilesel.src = "Resources/Sets/"+setName+"/sel.png";
tilesel.hOffset = 0;
tilesel.vOffset = 0;
tilesel.zOrder = 1001;
tilesel.opacity = 0;

var tilehint1 = new Image();
tilehint1.src = "Resources/Sets/"+setName+"/hint.png";
tilehint1.hOffset = 0;
tilehint1.vOffset = 0;
tilehint1.zOrder = 1002;
tilehint1.opacity = 0;

var tilehint2 = new Image();
tilehint2.src = "Resources/Sets/"+setName+"/hint.png";
tilehint2.hOffset = 0;
tilehint2.vOffset = 0;
tilehint2.zOrder = 1001;
tilehint2.opacity = 0;

var baseX = 40;
var baseY = 20;
var multX = 34;
var halfX = 17;
var multY = 42;
var halfY = 21;
var delta = 4;
var tiles = new Array();	// array delle immagini
var names = new Array('b1','b1','b1','b1','b2','b2','b2','b2','b3','b3','b3','b3','b4','b4','b4','b4','b5','b5','b5','b5','b6','b6','b6','b6','b7','b7','b7','b7','b8','b8','b8','b8','b9','b9','b9','b9','c1','c1','c1','c1','c2','c2','c2','c2','c3','c3','c3','c3','c4','c4','c4','c4','c5','c5','c5','c5','c6','c6','c6','c6','c7','c7','c7','c7','c8','c8','c8','c8','c9','c9','c9','c9','n1','n1','n1','n1','n2','n2','n2','n2','n3','n3','n3','n3','n4','n4','n4','n4','n5','n5','n5','n5','n6','n6','n6','n6','n7','n7','n7','n7','n8','n8','n8','n8','n9','n9','n9','n9','v1','v1','v1','v1','v2','v2','v2','v2','v3','v3','v3','v3','v4','v4','v4','v4','d1','d1','d1','d1','d2','d2','d2','d2','d3','d3','d3','d3','f1','f2','f3','f4','s1','s2','s3','s4');
var types = new Array(1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,6,6,6,6,7,7,7,7,8,8,8,8,9,9,9,9,10,10,10,10,11,11,11,11,12,12,12,12,13,13,13,13,14,14,14,14,15,15,15,15,16,16,16,16,17,17,17,17,18,18,18,18,19,19,19,19,20,20,20,20,21,21,21,21,22,22,22,22,23,23,23,23,24,24,24,24,25,25,25,25,26,26,26,26,27,27,27,27,28,28,28,28,29,29,29,29,30,30,30,30,31,31,31,31,32,32,32,32,33,33,33,33,34,34,34,34,35,35,35,35,36,36,36,36);
var rando = new Array();
var accop = new Array();
/*var hintOne = new Array();
var hintTwo = new Array();
var hintThree = new Array();
var hintFour = new Array();*/
var hintList = new Array();
var hintArray = new Array();
var hints = 0;
var couples = 0;

var pxclassic = new Array(0,   2,4,6,8,10,12,14,16,18,20,22,24,  6,8,10,12,14,16,18,20,     4,6,8,10,12,14,16,18,20,22,     2,4,6,8,10,12,14,16,18,20,22,24,      2,4,6,8,10,12,14,16,18,20,22,24,      4,6,8,10,12,14,16,18,20,22,       6,8,10,12,14,16,18,20,        2,4,6,8,10,12,14,16,18,20,22,24,        26,28,    8,10,12,14,16,18,    8,10,12,14,16,18,       8,10,12,14,16,18,        8,10,12,14,16,18,       8,10,12,14,16,18,          8,10,12,14,16,18,          10,12,14,16,       10,12,14,16,      10,12,14,16,      10,12,14,16,        12,14,    12,14,    13);
var pyclassic = new Array(7,   0,0,0,0,0,0,0,0,0,0,0,0,          2,2,2,2,2,2,2,2,           4,4,4,4,4,4,4,4,4,4,            6,6,6,6,6,6,6,6,6,6,6,6,              8,8,8,8,8,8,8,8,8,8,8,8,              10,10,10,10,10,10,10,10,10,10,    12,12,12,12,12,12,12,12,      14,14,14,14,14,14,14,14,14,14,14,14,    7,7,      2,2,2,2,2,2,         4,4,4,4,4,4,            6,6,6,6,6,6,             8,8,8,8,8,8,            10,10,10,10,10,10,         12,12,12,12,12,12,         4,4,4,4,           6,6,6,6,          8,8,8,8,          10,10,10,10,        6,6,      8,8,      7);
var llclassic = new Array(0,   0,0,0,0,0,0,0,0,0,0,0,0,          0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,            0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,                0,0,      1,1,1,1,1,1,         1,1,1,1,1,1,            1,1,1,1,1,1,             1,1,1,1,1,1,            1,1,1,1,1,1,               1,1,1,1,1,1,               2,2,2,2,           2,2,2,2,          2,2,2,2,          2,2,2,2,            3,3,      3,3,      4);
var f1classic = new Array(0,   0,2,3,4,5,6,7,8,9,10,11,12,       0,14,15,16,17,18,19,20,    0,22,23,24,25,26,27,28,29,30,   1,32,33,34,35,36,37,38,39,40,41,42,   1,44,45,46,47,48,49,50,51,52,53,54,   0,56,57,58,59,60,61,62,63,64,     0,66,67,68,69,70,71,72,       0,74,75,76,77,78,79,80,81,82,83,84,     43,86,    0,88,89,90,91,92,    0,94,95,96,97,98,       0,100,101,102,103,104,   0,106,107,108,109,110,  0,112,113,114,115,116,     0,118,119,120,121,122,     0,124,125,126,     0,128,129,130,    0,132,133,134,    0,136,137,138,      0,140,    0,142,    0);
var f2classic = new Array(0,   0,0,0,0,0,0,0,0,0,0,0,0,          0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,            0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,                55,0,     0,0,0,0,0,0,         0,0,0,0,0,0,            0,0,0,0,0,0,             0,0,0,0,0,0,            0,0,0,0,0,0,               0,0,0,0,0,0,               0,0,0,0,           0,0,0,0,          0,0,0,0,          0,0,0,0,            0,0,      0,0,      0);
var f3classic = new Array(32,  3,4,5,6,7,8,9,10,11,12,13,0,      15,16,17,18,19,20,21,0,    23,24,25,26,27,28,29,30,31,0,   33,34,35,36,37,38,39,40,41,42,43,86,  45,46,47,48,49,50,51,52,53,54,55,86,  57,58,59,60,61,62,63,64,65,0,     67,68,69,70,71,72,73,0,       75,76,77,78,79,80,81,82,83,84,85,0,     87,0,     89,90,91,92,93,0,    95,96,97,98,99,0,       101,102,103,104,105,0,   107,108,109,110,111,0,  113,114,115,116,117,0,     119,120,121,122,123,0,     125,126,127,0,     129,130,131,0,    133,134,135,0,    137,138,139,0,      141,0,    143,0,    0);
var f4classic = new Array(44,  0,0,0,0,0,0,0,0,0,0,0,0,          0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,            0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,                0,0,      0,0,0,0,0,0,         0,0,0,0,0,0,            0,0,0,0,0,0,             0,0,0,0,0,0,            0,0,0,0,0,0,               0,0,0,0,0,0,               0,0,0,0,           0,0,0,0,          0,0,0,0,          0,0,0,0,            0,0,      0,0,      0);
var f5classic = new Array(0,   0,0,0,0,0,0,0,0,0,0,0,0,          0,88,89,90,91,92,93,0,     0,0,94,95,96,97,98,99,0,0,      0,0,0,100,101,102,103,104,105,0,0,0,  0,0,0,106,107,108,109,110,111,0,0,0,  0,0,112,113,114,115,116,117,0,0,  0,118,119,120,121,122,123,0,  0,0,0,0,0,0,0,0,0,0,0,0,                0,0,      0,0,0,0,0,0,         0,124,125,126,127,0,    0,128,129,130,131,0,     0,132,133,134,135,0,    0,136,137,138,139,0,       0,0,0,0,0,0,               0,0,0,0,           0,140,141,0,      0,142,143,0,      0,0,0,0,            144,144,  144,144,  0);
var f6classic = new Array(0,   0,0,0,0,0,0,0,0,0,0,0,0,          0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,            0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,                0,0,      0,0,0,0,0,0,         0,0,0,0,0,0,            0,0,0,0,0,0,             0,0,0,0,0,0,            0,0,0,0,0,0,               0,0,0,0,0,0,               0,0,0,0,           0,0,0,0,          0,0,0,0,          0,0,0,0,            0,0,      0,0,      0);
var f7classic = new Array(0,   0,0,0,0,0,0,0,0,0,0,0,0,          0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,            0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,                0,0,      0,0,0,0,0,0,         0,0,0,0,0,0,            0,0,0,0,0,0,             0,0,0,0,0,0,            0,0,0,0,0,0,               0,0,0,0,0,0,               0,0,0,0,           0,0,0,0,          0,0,0,0,          0,0,0,0,            0,0,      0,0,      0);
var f8classic = new Array(0,   0,0,0,0,0,0,0,0,0,0,0,0,          0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,            0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,                0,0,      0,0,0,0,0,0,         0,0,0,0,0,0,            0,0,0,0,0,0,             0,0,0,0,0,0,            0,0,0,0,0,0,               0,0,0,0,0,0,               0,0,0,0,           0,0,0,0,          0,0,0,0,          0,0,0,0,            0,0,      0,0,      0);

var pxcastle = new Array(2,4,6,8,10,12,14,16,18,20,22,24,26,    2,  26, 2,   6,8,10,12,14,16,18,20,22,    26,  2,  6,8,10,12,14,16,18,20,22,    26,  2,   6,8,10,12,14,16,18,20,22,     26,   2,   26,  2,4,6,8,10,12,14,16,18,20,22,24,26,       2,  6,  10,  14,  18,  22,  26,  2,  6,8,10,12,14,16,18,20,22,             26,  6,8,10,12,14,16,18,20,22,            2,  6,8,10,12,14,16,18,20,22,             26,  2,   6,   10,  14,  18,  22,  26,  6,8,10,12,14,16,18,20,22,            6,8,10,12,       16,18,20,22,      6,8,10,12,14,16,18,20,22,             6,  10,  14,  18,  22,  6,  10,  14,  18,  22);
var pycastle = new Array(1,1,1,1,1,1,1,1,1,1,1,1,1,             3,  3,  5,   5,5,5,5,5,5,5,5,5,           5,   7,  7,7,7,7,7,7,7,7,7,           7,   9,   9,9,9,9,9,9,9,9,9,            9,    11,  11,  13,13,13,13,13,13,13,13,13,13,13,13,13,   1,  1,  1,   1,   1,   1,   1,   5,  5,5,5,5,5,5,5,5,5,                    5,   7,7,7,7,7,7,7,7,7,                   9,  9,9,9,9,9,9,9,9,9,                    9,   13,  13,  13,  13,  13,  13,  13,  5,5,5,5,5,5,5,5,5,                   7,7,7,7,         7,7,7,7,          9,9,9,9,9,9,9,9,9,                    5,  5,   5,   5,   5,   9,  9,   9,   9,   9);
var llcastle = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,             0,  0,  0,   0,0,0,0,0,0,0,0,0,           0,   0,  0,0,0,0,0,0,0,0,0,           0,   0,   0,0,0,0,0,0,0,0,0,            0,    0,   0,   0,0,0,0,0,0,0,0,0,0,0,0,0,                1,  1,  1,   1,   1,   1,   1,   1,  1,1,1,1,1,1,1,1,1,                    1,   1,1,1,1,1,1,1,1,1,                   1,  1,1,1,1,1,1,1,1,1,                    1,   1,   1,   1,   1,   1,   1,   1,   2,2,2,2,2,2,2,2,2,                   2,2,2,2,         2,2,2,2,          2,2,2,2,2,2,2,2,2,                    3,  3,   3,   3,   3,   3,  3,   3,   3,   3);
var f1castle = new Array(0,1,2,3,4,5,6,7,8,9,10,11,12,          0,  0,  0,   0,17,18,19,20,21,22,23,24,   0,   0,  0,28,29,30,31,32,33,34,35,   0,   0,   0,39,40,41,42,43,44,45,46,    0,    0,   0,   0,51,52,53,54,55,56,57,58,59,60,61,62,    0,  0,  0,   0,   0,   0,   0,   0,  0,72,73,74,75,76,77,78,79,            0,   0,82,83,84,85,86,87,88,89,           0,  0,92,93,94,95,96,97,98,99,            0,   0,   0,   0,   0,   0,   0,   0,   0,109,110,111,112,113,114,115,116,   0,118,119,120,   0,122,123,124,    0,126,127,128,129,130,131,132,133,    0,  0,   0,   0,   0,   0,  0,   0,   0,   0);
var f2castle = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,             0,  0,  0,   0,0,0,0,0,0,0,0,0,           0,   0,  0,0,0,0,0,0,0,0,0,           0,   0,   0,0,0,0,0,0,0,0,0,            0,    0,   0,   0,0,0,0,0,0,0,0,0,0,0,0,0,                0,  0,  0,   0,   0,   0,   0,   0,  0,0,0,0,0,0,0,0,0,                    0,   0,0,0,0,0,0,0,0,0,                   0,  0,0,0,0,0,0,0,0,0,                    0,   0,   0,   0,   0,   0,   0,   0,   0,0,0,0,0,0,0,0,0,                   0,0,0,0,         0,0,0,0,          0,0,0,0,0,0,0,0,0,                    0,  0,   0,   0,   0,   0,  0,   0,   0,   0);
var f3castle = new Array(2,3,4,5,6,7,8,9,10,11,12,13,0,         0,  0,  0,   18,19,20,21,22,23,24,25,0,   0,   0,  29,30,31,32,33,34,35,36,0,   0,   0,   40,41,42,43,44,45,46,47,0,    0,	  0,   0,   52,53,54,55,56,57,58,59,60,61,62,63,0,    0,  0,  0,   0,   0,   0,   0,   0,  73,74,75,76,77,78,79,80,0,            0,   83,84,85,86,87,88,89,90,0,           0,  93,94,95,96,97,98,99,100,0,           0,   0,   0,   0,   0,   0,   0,   0,   110,111,112,113,114,115,116,117,0,   119,120,121,0,   123,124,125,0,    127,128,129,130,131,132,133,134,0,    0,  0,   0,   0,   0,   0,  0,   0,   0,   0);
var f4castle = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,             0,  0,  0,   0,0,0,0,0,0,0,0,0,           0,   0,  0,0,0,0,0,0,0,0,0,           0,   0,   0,0,0,0,0,0,0,0,0,            0,    0,   0,   0,0,0,0,0,0,0,0,0,0,0,0,0,                0,  0,  0,   0,   0,   0,   0,   0,  0,0,0,0,0,0,0,0,0,                    0,   0,0,0,0,0,0,0,0,0,                   0,  0,0,0,0,0,0,0,0,0,                    0,   0,   0,   0,   0,   0,   0,   0,   0,0,0,0,0,0,0,0,0,                   0,0,0,0,         0,0,0,0,          0,0,0,0,0,0,0,0,0,                    0,  0,   0,   0,   0,   0,  0,   0,   0,   0);
var f5castle = new Array(64,0,65,0,66,0,67,0,68,0,69,0,70,      0,  0,  71,  72,73,74,75,76,77,78,79,80,  81,  0,  82,83,84,85,86,87,88,89,90,  0,   91,  92,93,94,95,96,97,98,99,100,  101,  0,   0,   102,0,103,0,104,0,105,0,106,0,107,0,108,  0,  0,  0,   0,   0,   0,   0,   0,  109,110,111,112,113,114,115,116,117,  0,   118,119,120,121,0,122,123,124,125,   0,  126,127,128,129,130,131,132,133,134,  0,   0,   0,   0,   0,   0,   0,   0,   135,0,136,0,137,0,138,0,139,         0,0,0,0,         0,0,0,0,          140,0,141,0,142,0,143,0,144,          0,  0,   0,   0,   0,   0,  0,   0,   0,   0);
var f6castle = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,             0,  0,  0,   0,0,0,0,0,0,0,0,0,           0,   0,  0,0,0,0,0,0,0,0,0,           0,   0,   0,0,0,0,0,0,0,0,0,            0,    0,   0,   0,0,0,0,0,0,0,0,0,0,0,0,0,                0,  0,  0,   0,   0,   0,   0,   0,  0,0,0,0,0,0,0,0,0,                    0,   0,0,0,0,0,0,0,0,0,                   0,  0,0,0,0,0,0,0,0,0,                    0,   0,   0,   0,   0,   0,   0,   0,   0,0,0,0,0,0,0,0,0,                   0,0,0,0,         0,0,0,0,          0,0,0,0,0,0,0,0,0,                    0,  0,   0,   0,   0,   0,  0,   0,   0,   0);
var f7castle = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,             0,  0,  0,   0,0,0,0,0,0,0,0,0,           0,   0,  0,0,0,0,0,0,0,0,0,           0,   0,   0,0,0,0,0,0,0,0,0,            0,    0,   0,   0,0,0,0,0,0,0,0,0,0,0,0,0,                0,  0,  0,   0,   0,   0,   0,   0,  0,0,0,0,0,0,0,0,0,                    0,   0,0,0,0,0,0,0,0,0,                   0,  0,0,0,0,0,0,0,0,0,                    0,   0,   0,   0,   0,   0,   0,   0,   0,0,0,0,0,0,0,0,0,                   0,0,0,0,         0,0,0,0,          0,0,0,0,0,0,0,0,0,                    0,  0,   0,   0,   0,   0,  0,   0,   0,   0);
var f8castle = new Array(0,0,0,0,0,0,0,0,0,0,0,0,0,             0,  0,  0,   0,0,0,0,0,0,0,0,0,           0,   0,  0,0,0,0,0,0,0,0,0,           0,   0,   0,0,0,0,0,0,0,0,0,            0,    0,   0,   0,0,0,0,0,0,0,0,0,0,0,0,0,                0,  0,  0,   0,   0,   0,   0,   0,  0,0,0,0,0,0,0,0,0,                    0,   0,0,0,0,0,0,0,0,0,                   0,  0,0,0,0,0,0,0,0,0,                    0,   0,   0,   0,   0,   0,   0,   0,   0,0,0,0,0,0,0,0,0,                   0,0,0,0,         0,0,0,0,          0,0,0,0,0,0,0,0,0,                    0,  0,   0,   0,   0,   0,  0,   0,   0,   0);

var pxpyramid = new Array(4,6,8,10,12,14,16,  24,  2,4,6,8,10,12,14,16,18,      0,2,4,6,8,10,12,14,16,18,20,       0,2,4,6,8,10,12,14,16,18,20,22,       0,2,4,6,8,10,12,14,16,18,20,           2,4,6,8,10,12,14,16,18,             4,6,8,10,12,14,16,     24,  4,6,8,10,12,14,16,       2,4,6,8,10,12,14,16,18,             2,4,6,8,10,12,14,16,18,20,              2,4,6,8,10,12,14,16,18,             4,6,8,10,12,14,16,              4,6,8,10,12,14,16,            4,6,8,10,12,14,16,18,              4,6,8,10,12,14,16,            6,8,10,12,14,16,           8,10,12,14,       10,12);
var pypyramid = new Array(1,1,1,1,1,1,1,      1,   3,3,3,3,3,3,3,3,3,           5,5,5,5,5,5,5,5,5,5,5,             7,7,7,7,7,7,7,7,7,7,7,7,              9,9,9,9,9,9,9,9,9,9,9,                 11,11,11,11,11,11,11,11,11,         13,13,13,13,13,13,13,  13,  3,3,3,3,3,3,3,           5,5,5,5,5,5,5,5,5,                  7,7,7,7,7,7,7,7,7,7,                    9,9,9,9,9,9,9,9,9,                  11,11,11,11,11,11,11,           5,5,5,5,5,5,5,                7,7,7,7,7,7,7,7,                   9,9,9,9,9,9,9,                7,7,7,7,7,7,               7,7,7,7,          7,7);
var llpyramid = new Array(0,0,0,0,0,0,0,      0,   0,0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,                 0,0,0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,         0,   1,1,1,1,1,1,1,           1,1,1,1,1,1,1,1,1,                  1,1,1,1,1,1,1,1,1,1,                    1,1,1,1,1,1,1,1,1,                  1,1,1,1,1,1,1,                  2,2,2,2,2,2,2,                2,2,2,2,2,2,2,2,                   2,2,2,2,2,2,2,                3,3,3,3,3,3,               4,4,4,4,          5,5);
var f1pyramid = new Array(0,1,2,3,4,5,6,      0,   0,9,10,11,12,13,14,15,16,    0,18,19,20,21,22,23,24,25,26,27,   0,29,30,31,32,33,34,35,36,37,38,39,   0,41,42,43,44,45,46,47,48,49,50,       0,52,53,54,55,56,57,58,59,          0,61,62,63,64,65,66,   0,   0,69,70,71,72,73,74,     0,76,77,78,79,80,81,82,83,          0,85,86,87,88,89,90,91,92,93,           0,95,96,97,98,99,100,101,102,       0,104,105,106,107,108,109,      0,111,112,113,114,115,116,    0,118,119,120,121,122,123,124,     0,126,127,128,129,130,131,    0,133,134,135,136,137,     0,139,140,141,    0,143);
var f2pyramid = new Array(0,0,0,0,0,0,0,      0,   0,0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,                 0,0,0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,         0,   0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,0,0,0,                    0,0,0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,                0,0,0,0,0,0,0,0,                   0,0,0,0,0,0,0,                0,0,0,0,0,0,               0,0,0,0,          0,0);
var f3pyramid = new Array(2,3,4,5,6,7,0,      0,   10,11,12,13,14,15,16,17,0,   19,20,21,22,23,24,25,26,27,28,0,   30,31,32,33,34,35,36,37,38,39,40,0,   42,43,44,45,46,47,48,49,50,51,0,       53,54,55,56,57,58,59,60,0,          62,63,64,65,66,67,0,   0,   70,71,72,73,74,75,0,     77,78,79,80,81,82,83,84,0,          86,87,88,89,90,91,92,93,94,0,           96,97,98,99,100,101,102,103,0,      105,106,107,108,109,110,0,      112,113,114,115,116,117,0,    119,120,121,122,123,124,125,0,     127,128,129,130,131,132,0,    134,135,136,137,138,0,     140,141,142,0,    144,0);
var f4pyramid = new Array(0,0,0,0,0,0,0,      0,   0,0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,                 0,0,0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,         0,   0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,0,0,0,                    0,0,0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,                0,0,0,0,0,0,0,0,                   0,0,0,0,0,0,0,                0,0,0,0,0,0,               0,0,0,0,          0,0);
var f5pyramid = new Array(0,0,0,0,0,0,0,      0,   0,69,70,71,72,73,74,75,0,    0,76,77,78,79,80,81,82,83,84,0,    0,85,86,87,88,89,90,91,92,93,94,0,    0,95,96,97,98,99,100,101,102,103,0,    0,104,105,106,107,108,109,110,0,    0,0,0,0,0,0,0,         0,   0,0,0,0,0,0,0,           0,111,112,113,114,115,116,117,0,    0,118,119,120,121,122,123,124,125,0,    0,126,127,128,129,130,131,132,0,    0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,                0,133,134,135,136,137,138,0,       0,0,0,0,0,0,0,                0,139,140,141,142,0,       0,143,144,0,      0,0);
var f6pyramid = new Array(0,0,0,0,0,0,0,      0,   0,0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,                 0,0,0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,         0,   0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,0,0,0,                    0,0,0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,                0,0,0,0,0,0,0,0,                   0,0,0,0,0,0,0,                0,0,0,0,0,0,               0,0,0,0,          0,0);
var f7pyramid = new Array(0,0,0,0,0,0,0,      0,   0,0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,                 0,0,0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,         0,   0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,0,0,0,                    0,0,0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,                0,0,0,0,0,0,0,0,                   0,0,0,0,0,0,0,                0,0,0,0,0,0,               0,0,0,0,          0,0);
var f8pyramid = new Array(0,0,0,0,0,0,0,      0,   0,0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,                 0,0,0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,         0,   0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,0,0,0,                    0,0,0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,                  0,0,0,0,0,0,0,                0,0,0,0,0,0,0,0,                   0,0,0,0,0,0,0,                0,0,0,0,0,0,               0,0,0,0,          0,0);

var pxsquares = new Array(3,5,7,       15,17,19,    3,5,7,       15,17,19,    9,11,13,     21,23,25,    9,11,13,     21,23,25,    3,5,7,       15,17,19,    3,5,7,       15,17,19,    9,11,13,     21,23,25,    9,11,13,     21,23,25,    3,5,7,       15,17,19,       3,5,7,          15,17,19,       9,11,13,        21,23,25,       9,11,13,        21,23,25,       3,5,7,          15,17,19,       3,5,7,          15,17,19,       9,11,13,        21,23,25,       9,11,13,        21,23,25,       3,5,7,      15,17,19,     3,5,7,        15,17,19,     9,11,13,      21,23,25,     9,11,13,      21,23,25,     3,5,7,        15,17,19,     3,5,7,        15,17,19,     9,11,13,      21,23,25,     9,11,13,      21,23,25);
var pysquares = new Array(0,0,0,       0,0,0,       2,2,2,       2,2,2,       4,4,4,       4,4,4,       6,6,6,       6,6,6,       8,8,8,       8,8,8,       10,10,10,    10,10,10,    12,12,12,    12,12,12,    14,14,14,    14,14,14,    0,0,0,       0,0,0,          2,2,2,          2,2,2,          4,4,4,          4,4,4,          6,6,6,          6,6,6,          8,8,8,          8,8,8,          10,10,10,       10,10,10,       12,12,12,       12,12,12,       14,14,14,       14,14,14,       0,0,0,      0,0,0,        2,2,2,        2,2,2,        4,4,4,        4,4,4,        6,6,6,        6,6,6,        8,8,8,        8,8,8,        10,10,10,     10,10,10,     12,12,12,     12,12,12,     14,14,14,     14,14,14);
var llsquares = new Array(0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       1,1,1,       1,1,1,          1,1,1,          1,1,1,          1,1,1,          1,1,1,          1,1,1,          1,1,1,          1,1,1,          1,1,1,          1,1,1,          1,1,1,          1,1,1,          1,1,1,          1,1,1,          1,1,1,          2,2,2,      2,2,2,        2,2,2,        2,2,2,        2,2,2,        2,2,2,        2,2,2,        2,2,2,        2,2,2,        2,2,2,        2,2,2,        2,2,2,        2,2,2,        2,2,2,        2,2,2,        2,2,2);
var f1squares = new Array(0,1,2,       0,4,5,       0,7,8,       0,10,11,     0,13,14,     0,16,17,     0,19,20,     0,22,23,     0,25,26,     0,28,29,     0,31,32,     0,34,35,     0,37,38,     0,40,41,     0,43,44,     0,46,47,     0,49,50,     0,52,53,        0,55,56,        0,58,59,        0,61,62,        0,64,65,        0,67,68,        0,70,71,        0,73,74,        0,76,77,        0,79,80,        0,82,83,        0,85,86,        0,88,89,        0,91,92,        0,94,95,        0,97,98,    0,100,101,    0,103,104,    0,106,107,    0,109,110,    0,112,113,    0,115,116,    0,118,119,    0,121,122,    0,124,125,    0,127,128,    0,130,131,    0,133,134,    0,136,137,    0,139,140,    0,142,143);
var f2squares = new Array(0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,      0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0);
var f3squares = new Array(2,3,0,       5,6,0,       8,9,0,       11,12,0,     14,15,0,     17,18,0,     20,21,0,     23,24,0,     26,27,0,     29,30,0,     32,33,0,     35,36,0,     38,39,0,     41,42,0,     44,45,0,     47,48,0,     50,51,0,     53,54,0,        56,57,0,        59,60,0,        62,63,0,        65,66,0,        68,69,0,        71,72,0,        74,75,0,        77,78,0,        80,81,0,        83,84,0,        86,87,0,        89,90,0,        92,93,0,        95,96,0,        98,99,0,    101,102,0,    104,105,0,    107,108,0,    110,111,0,    113,114,0,    116,117,0,    119,120,0,    122,123,0,    125,126,0,    128,129,0,    131,132,0,    134,135,0,    137,138,0,    140,141,0,    143,144,0);
var f4squares = new Array(0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,      0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0);
var f5squares = new Array(49,50,51,    52,53,54,    55,56,57,    58,59,60,    61,62,63,    64,65,66,    67,68,69,    70,71,72,    73,74,75,    76,77,78,    79,80,81,    82,83,84,    85,86,87,    88,89,90,    91,92,93,    94,95,96,    97,98,99,    100,101,102,    103,104,105,    106,107,108,    109,110,111,    112,113,114,    115,116,117,    118,119,120,    121,122,123,    124,125,126,    127,128,129,    130,131,132,    133,134,135,    136,137,138,    139,140,141,    142,143,144,    0,0,0,      0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0);
var f6squares = new Array(0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,      0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0);
var f7squares = new Array(0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,      0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0);
var f8squares = new Array(0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,       0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,          0,0,0,      0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0,        0,0,0);

var pxomega = new Array(6,8,10,12,14,16,18,20,22,     4,6,8,10,     18,20,22,24,  3,5,7,9,      19,21,23,25,  2,4,6,8,      20,22,24,26,  3,5,7,9,      19,21,23,25,    4,6,8,10,         18,20,22,24,      6,8,10,12,        16,18,20,22,      2,4,6,8,10,12,            16,18,20,22,24,26,        7,9,11,13,15,17,19,21,        5,7,9,     19,21,23,   4,6,8,    20,22,24,   3,5,7,     21,23,25,    4,6,8,     20,22,24,    5,7,9,      19,21,23,   7,9,11,     17,19,21,   3,5,7,9,11,         17,19,21,23,25,     10,12,14,16,18,     7,   21,  6,   22,  5,   23,  6,   22,  7,   21,  9,   19,  7,9,     19,21);
var pyomega = new Array(0,0,0,0,0,0,0,0,0,            2,2,2,2,      2,2,2,2,      4,4,4,4,      4,4,4,4,      6,6,6,6,      6,6,6,6,      8,8,8,8,      8,8,8,8,        10,10,10,10,      10,10,10,10,      12,12,12,12,      12,12,12,12,      14,14,14,14,14,14,        14,14,14,14,14,14,        0,0,0,0,0,0,0,0,              2,2,2,     2,2,2,      4,4,4,    4,4,4,      6,6,6,     6,6,6,       8,8,8,     8,8,8,       10,10,10,   10,10,10,   12,12,12,   12,12,12,   14,14,14,14,14,     14,14,14,14,14,     0,0,0,0,0,          2,   2,   4,   4,   6,   6,   8,   8,   10,  10,  12,  12,  14,14,   14,14);
var llomega = new Array(0,0,0,0,0,0,0,0,0,            0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,        0,0,0,0,          0,0,0,0,          0,0,0,0,          0,0,0,0,          0,0,0,0,0,0,              0,0,0,0,0,0,              1,1,1,1,1,1,1,1,              1,1,1,     1,1,1,      1,1,1,    1,1,1,      1,1,1,     1,1,1,       1,1,1,     1,1,1,       1,1,1,      1,1,1,      1,1,1,      1,1,1,      1,1,1,1,1,          1,1,1,1,1,          2,2,2,2,2,          2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,2,     2,2);
var f1omega = new Array(0,1,2,3,4,5,6,7,8,            0,10,11,12,   0,14,15,16,   0,18,19,20,   0,22,23,24,   0,26,27,28,   0,30,31,32,   0,34,35,36,   0,38,39,40,     0,42,43,44,       0,46,47,48,       0,50,51,52,       0,54,55,56,       0,58,59,60,61,62,         0,64,65,66,67,68,         0,70,71,72,73,74,75,76,       0,78,79,   0,81,82,    0,84,85,  0,87,88,    0,90,91,   0,93,94,     0,96,97,   0,99,100,    0,102,103,  0,105,106,  0,108,109,  0,111,112,  0,114,115,116,117,  0,119,120,121,122,  0,124,125,126,127,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,141,   0,143);
var f2omega = new Array(0,0,0,0,0,0,0,0,0,            0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,        0,0,0,0,          0,0,0,0,          0,0,0,0,          0,0,0,0,          0,0,0,0,0,0,              0,0,0,0,0,0,              0,0,0,0,0,0,0,0,              0,0,0,     0,0,0,      0,0,0,    0,0,0,      0,0,0,     0,0,0,       0,0,0,     0,0,0,       0,0,0,      0,0,0,      0,0,0,      0,0,0,      0,0,0,0,0,          0,0,0,0,0,          0,0,0,0,0,          0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,0,     0,0);
var f3omega = new Array(2,3,4,5,6,7,8,9,0,            11,12,13,0,   15,16,17,0,   19,20,21,0,   23,24,25,0,   27,28,29,0,   31,32,33,0,   35,36,37,0,   39,40,41,0,     43,44,45,0,       47,48,49,0,       51,52,53,0,       55,56,57,0,       59,60,61,62,63,0,         65,66,67,68,69,0,         71,72,73,74,75,76,77,0,       79,80,0,   82,83,0,    85,86,0,  88,89,0,    91,92,0,   94,95,0,     97,98,0,   100,101,0,   103,104,0,  106,107,0,  109,110,0,  112,113,0,  115,116,117,118,0,  120,121,122,123,0,  125,126,127,128,0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   142,0,   144,0);
var f4omega = new Array(0,0,0,0,0,0,0,0,0,            0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,        0,0,0,0,          0,0,0,0,          0,0,0,0,          0,0,0,0,          0,0,0,0,0,0,              0,0,0,0,0,0,              0,0,0,0,0,0,0,0,              0,0,0,     0,0,0,      0,0,0,    0,0,0,      0,0,0,     0,0,0,       0,0,0,     0,0,0,       0,0,0,      0,0,0,      0,0,0,      0,0,0,      0,0,0,0,0,          0,0,0,0,0,          0,0,0,0,0,          0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,0,     0,0);
var f5omega = new Array(70,70,71,72,73,74,75,76,77,   78,78,79,80,  81,81,82,83,  84,84,85,86,  87,87,88,89,  90,90,91,92,  93,93,94,95,  96,96,97,98,  99,99,100,101,  102,102,103,104,  105,105,106,107,  108,108,109,110,  111,111,112,113,  114,114,115,116,117,118,  119,119,120,121,122,123,  0,124,124,125,126,127,128,0,  0,129,0,   0,130,0,    0,131,0,  0,132,0,    0,133,0,   0,134,0,     0,135,0,   0,136,0,     0,137,0,    0,138,0,    0,139,0,    0,140,0,    0,0,141,142,0,      0,143,144,0,0,      0,0,0,0,0,          0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,0,     0,0);
var f6omega = new Array(0,71,72,73,74,75,76,77,0,     0,79,80,0,    0,82,83,0,    0,85,86,0,    0,88,89,0,    0,91,92,0,    0,94,95,0,    0,97,98,0,    0,100,101,0,    0,103,104,0,      0,106,107,0,      0,109,110,0,      0,112,113,0,      0,115,116,117,118,0,      0,120,121,122,123,0,      0,0,125,126,127,128,0,0,      0,0,0,     0,0,0,      0,0,0,    0,0,0,      0,0,0,     0,0,0,       0,0,0,     0,0,0,       0,0,0,      0,0,0,      0,0,0,      0,0,0,      0,0,0,0,0,          0,0,0,0,0,          0,0,0,0,0,          0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,0,     0,0);
var f7omega = new Array(0,0,0,0,0,0,0,0,0,            0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,        0,0,0,0,          0,0,0,0,          0,0,0,0,          0,0,0,0,          0,0,0,0,0,0,              0,0,0,0,0,0,              0,0,0,0,0,0,0,0,              0,0,0,     0,0,0,      0,0,0,    0,0,0,      0,0,0,     0,0,0,       0,0,0,     0,0,0,       0,0,0,      0,0,0,      0,0,0,      0,0,0,      0,0,0,0,0,          0,0,0,0,0,          0,0,0,0,0,          0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,0,     0,0);
var f8omega = new Array(0,0,0,0,0,0,0,0,0,            0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,      0,0,0,0,        0,0,0,0,          0,0,0,0,          0,0,0,0,          0,0,0,0,          0,0,0,0,0,0,              0,0,0,0,0,0,              0,0,0,0,0,0,0,0,              0,0,0,     0,0,0,      0,0,0,    0,0,0,      0,0,0,     0,0,0,       0,0,0,     0,0,0,       0,0,0,      0,0,0,      0,0,0,      0,0,0,      0,0,0,0,0,          0,0,0,0,0,          0,0,0,0,0,          0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,0,     0,0);

var pxtowers = new Array(5,7,9,      19,21,23,   4,6,8,10,      18,20,22,24,   3,5,7,9,11,       17,19,21,23,25,  2,4,6,8,10,12,       16,18,20,22,24,26,   3,5,7,9,11,	     17,19,21,23,25,   4,6,8,10,     18,20,22,24,      5,7,9,        19,21,23,      6,8,    20,22,  5,7,9,         19,21,23,     4,6,8,10,          18,20,22,24,       3,5,7,9,11,           17,19,21,23,25,        4,6,8,10,          18,20,22,24,       5,7,9,         19,21,23,      6,8,    20,22,   6,8,    20,22,   5,7,9,      19,21,23,   4,6,8,10,       18,20,22,24,    5,7,9,      19,21,23,   6,8,     20,22,    7,    21,   6,8,      20,22,    7,    21,   7,    21);
var pytowers = new Array(1,1,1,      1,1,1,      3,3,3,3,       3,3,3,3,       5,5,5,5,5,        5,5,5,5,5,       7,7,7,7,7,7,         7,7,7,7,7,7,         9,9,9,9,9,       9,9,9,9,9,        11,11,11,11,  11,11,11,11,      13,13,13,     13,13,13,      1,1,    1,1,    3,3,3,         3,3,3,        5,5,5,5,           5,5,5,5,           7,7,7,7,7,            7,7,7,7,7,             9,9,9,9,           9,9,9,9,           11,11,11,      11,11,11,      13,13,  13,13,   3,3,    3,3,     5,5,5,      5,5,5,      7,7,7,7,        7,7,7,7,        9,9,9,      9,9,9,      11,11,   11,11,    5,    5,    7,7,      7,7,      9,    9,    7,    7);
var lltowers = new Array(0,0,0,      0,0,0,      0,0,0,0,       0,0,0,0,       0,0,0,0,0,        0,0,0,0,0,       0,0,0,0,0,0,         0,0,0,0,0,0,         0,0,0,0,0,       0,0,0,0,0,        0,0,0,0,      0,0,0,0,          0,0,0,        0,0,0,         1,1,    1,1,    1,1,1,         1,1,1,        1,1,1,1,           1,1,1,1,           1,1,1,1,1,            1,1,1,1,1,             1,1,1,1,           1,1,1,1,           1,1,1,         1,1,1,         1,1,    1,1,     2,2,    2,2,     2,2,2,      2,2,2,      2,2,2,2,        2,2,2,2,        2,2,2,      2,2,2,      2,2,     2,2,      3,    3,    3,3,      3,3,      3,    3,    4,    4);
var f1towers = new Array(0,1,2,      0,4,5,      0,7,8,9,       0,11,12,13,    0,15,16,17,18,    0,20,21,22,23,   0,25,26,27,28,29,    0,31,32,33,34,35,    0,37,38,39,40,   0,42,43,44,45,    0,47,48,49,   0,51,52,53,       0,55,56,      0,58,59,       0,61,   0,63,   0,65,66,       0,68,69,      0,71,72,73,        0,75,76,77,        0,79,80,81,82,        0,84,85,86,87,         0,89,90,91,        0,93,94,95,        0,97,98,       0,100,101,     0,103,  0,105,   0,107,  0,109,   0,111,112,  0,114,115,  0,117,118,119,  0,121,122,123,  0,125,126,  0,128,129,  0,131,   0,133,    0,    0,    0,137,    0,139,    0,    0,    0,    0);
var f2towers = new Array(0,0,0,      0,0,0,      0,0,0,0,       0,0,0,0,       0,0,0,0,0,        0,0,0,0,0,       0,0,0,0,0,0,         0,0,0,0,0,0,         0,0,0,0,0,       0,0,0,0,0,        0,0,0,0,      0,0,0,0,          0,0,0,        0,0,0,         0,0,    0,0,    0,0,0,         0,0,0,        0,0,0,0,           0,0,0,0,           0,0,0,0,0,            0,0,0,0,0,             0,0,0,0,           0,0,0,0,           0,0,0,         0,0,0,         0,0,    0,0,     0,0,    0,0,     0,0,0,      0,0,0,      0,0,0,0,        0,0,0,0,        0,0,0,      0,0,0,      0,0,     0,0,      0,    0,    0,0,      0,0,      0,    0,    0,    0);
var f3towers = new Array(2,3,0,      5,6,0,      8,9,10,0,      12,13,14,0,    16,17,18,19,0,    21,22,23,24,0,   26,27,28,29,30,0,    32,33,34,35,36,0,    38,39,40,41,0,   43,44,45,46,0,    48,49,50,0,   52,53,54,0,       56,57,0,      59,60,0,       62,0,   64,0,   66,67,0,       69,70,0,      72,73,74,0,        76,77,78,0,        80,81,82,83,0,        85,86,87,88,0,         90,91,92,0,        94,95,96,0,        98,99,0,       101,102,0,     104,0,  106,0,   108,0,  110,0,   112,113,0,  115,116,0,  118,119,120,0,  122,123,124,0,  126,127,0,  129,130,0,  132,0,   134,0,    0,    0,    138,0,    140,0,    0,    0,    0,    0);
var f4towers = new Array(0,0,0,      0,0,0,      0,0,0,0,       0,0,0,0,       0,0,0,0,0,        0,0,0,0,0,       0,0,0,0,0,0,         0,0,0,0,0,0,         0,0,0,0,0,       0,0,0,0,0,        0,0,0,0,      0,0,0,0,          0,0,0,        0,0,0,         0,0,    0,0,    0,0,0,         0,0,0,        0,0,0,0,           0,0,0,0,           0,0,0,0,0,            0,0,0,0,0,             0,0,0,0,           0,0,0,0,           0,0,0,         0,0,0,         0,0,    0,0,     0,0,    0,0,     0,0,0,      0,0,0,      0,0,0,0,        0,0,0,0,        0,0,0,      0,0,0,      0,0,     0,0,      0,    0,    0,0,      0,0,      0,    0,    0,    0);
var f5towers = new Array(61,61,62,   63,63,64,   65,65,66,67,   68,68,69,70,   71,71,72,73,74,   75,75,76,77,78,  79,79,80,81,82,83,   84,84,85,86,87,88,   89,89,90,91,92,  93,93,94,95,96,   97,97,98,99,  100,100,101,102,  103,103,104,  105,105,106,   0,0,    0,0,    107,107,108,   109,109,110,  111,111,112,113,   114,114,115,116,   117,117,118,119,120,  121,121,122,123,124,   125,125,126,127,   128,128,129,130,   131,131,132,   133,133,134,   0,0,    0,0,     0,0,    0,0,     0,135,0,    0,136,0,    0,137,138,0,    0,139,140,0,    0,141,0,    0,142,0,    0,0,     0,0,      0,    0,    143,143,  144,144,  0,    0,    0,    0);
var f6towers = new Array(0,62,0,     0,64,0,     0,66,67,0,     0,69,70,0,     0,72,73,74,0,     0,76,77,78,0,    0,80,81,82,83,0,     0,85,86,87,88,0,     0,90,91,92,0,    0,94,95,96,0,     0,98,99,0,    0,101,102,0,      0,104,0,      0,106,0,       0,0,    0,0,    0,108,0,       0,110,0,      0,112,113,0,       0,115,116,0,       0,118,119,120,0,      0,122,123,124,0,       0,126,127,0,       0,129,130,0,       0,132,0,       0,134,0,       0,0,    0,0,     0,0,    0,0,     0,0,0,      0,0,0,      0,0,0,0,        0,0,0,0,        0,0,0,      0,0,0,      0,0,     0,0,      0,    0,    0,0,      0,0,      0,    0,    0,    0);
var f7towers = new Array(0,0,0,      0,0,0,      0,0,0,0,       0,0,0,0,       0,0,0,0,0,        0,0,0,0,0,       0,0,0,0,0,0,         0,0,0,0,0,0,         0,0,0,0,0,       0,0,0,0,0,        0,0,0,0,      0,0,0,0,          0,0,0,        0,0,0,         0,0,    0,0,    0,0,0,         0,0,0,        0,0,0,0,           0,0,0,0,           0,0,0,0,0,            0,0,0,0,0,             0,0,0,0,           0,0,0,0,           0,0,0,         0,0,0,         0,0,    0,0,     0,0,    0,0,     0,0,0,      0,0,0,      0,0,0,0,        0,0,0,0,        0,0,0,      0,0,0,      0,0,     0,0,      0,    0,    0,0,      0,0,      0,    0,    0,    0);
var f8towers = new Array(0,0,0,      0,0,0,      0,0,0,0,       0,0,0,0,       0,0,0,0,0,        0,0,0,0,0,       0,0,0,0,0,0,         0,0,0,0,0,0,         0,0,0,0,0,       0,0,0,0,0,        0,0,0,0,      0,0,0,0,          0,0,0,        0,0,0,         0,0,    0,0,    0,0,0,         0,0,0,        0,0,0,0,           0,0,0,0,           0,0,0,0,0,            0,0,0,0,0,             0,0,0,0,           0,0,0,0,           0,0,0,         0,0,0,         0,0,    0,0,     0,0,    0,0,     0,0,0,      0,0,0,      0,0,0,0,        0,0,0,0,        0,0,0,      0,0,0,      0,0,     0,0,      0,    0,    0,0,      0,0,      0,    0,    0,    0);

var pxinfi = new Array(4,6,8,10,    18,20,22,24,    2,4,6,8,10,12,     16,18,20,22,24,26,    0,2,4,6,8,10,12,14,16,18,20,22,24,26,28,       0,2,4,      10,12,14,16,18,         24,26,28,    0,2,4,6,8,10,12,14,16,18,20,22,24,26,28,                   2,4,6,8,10,12,           16,18,20,22,24,26,       4,6,8,10,      18,20,22,24,    4,6,8,10,     18,20,22,24,   2,4,6,8,10,12,      16,18,20,22,24,26,    2,4,    10,12,14,16,18,     24,26,   2,4,6,8,10,12,           16,18,20,22,24,26,      4,6,8,10,       18,20,22,24,    6,8,    20,22,    4,    10,12,    16,18,    24,   6,8,      20,22);
var pyinfi = new Array(1,1,1,1,     1,1,1,1,        3,3,3,3,3,3,       3,3,3,3,3,3,          5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,                 7,7,7,      7,7,7,7,7,              7,7,7,       9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,                             11,11,11,11,11,11,       11,11,11,11,11,11,       13,13,13,13,   13,13,13,13,    3,3,3,3,      3,3,3,3,       5,5,5,5,5,5,        5,5,5,5,5,5,          7,7,    7,7,7,7,7,          7,7,     9,9,9,9,9,9,             9,9,9,9,9,9,            11,11,11,11,    11,11,11,11,    5,5,    5,5,      7,    7,7,      7,7,      7,    9,9,      9,9);
var llinfi = new Array(0,0,0,0,     0,0,0,0,        0,0,0,0,0,0,       0,0,0,0,0,0,          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,                 0,0,0,      0,0,0,0,0,              0,0,0,       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,                             0,0,0,0,0,0,             0,0,0,0,0,0,             0,0,0,0,       0,0,0,0,        1,1,1,1,      1,1,1,1,       1,1,1,1,1,1,        1,1,1,1,1,1,          1,1,    1,1,1,1,1,          1,1,     1,1,1,1,1,1,             1,1,1,1,1,1,            1,1,1,1,        1,1,1,1,        2,2,    2,2,      2,    2,2,      2,2,      2,    2,2,      2,2);
var f1infi = new Array(0,1,2,3,     0,5,6,7,        0,9,10,11,12,13,   0,15,16,17,18,19,     0,21,22,23,24,25,26,27,28,29,30,31,32,33,34,   0,36,37,    0,39,40,41,42,          0,44,45,     0,47,48,49,50,51,52,53,54,55,56,57,58,59,60,               0,62,63,64,65,66,        0,68,69,70,71,72,        0,74,75,76,    0,78,79,80,     0,82,83,84,   0,86,87,88,    0,90,91,92,93,94,   0,96,97,98,99,100,    0,102,  0,104,105,106,107,  0,109,   0,111,112,113,114,115,   0,117,118,119,120,121,  0,123,124,125,  0,127,128,129,  0,131,  0,133,    0,    0,136,    0,138,    0,    0,141,    0,143);
var f2infi = new Array(0,0,0,0,     0,0,0,0,        0,0,0,0,0,0,       0,0,0,0,0,0,          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,                 0,0,0,      0,0,0,0,0,              0,0,0,       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,                             0,0,0,0,0,0,             0,0,0,0,0,0,             0,0,0,0,       0,0,0,0,        0,0,0,0,      0,0,0,0,       0,0,0,0,0,0,        0,0,0,0,0,0,          0,0,    0,0,0,0,0,          0,0,     0,0,0,0,0,0,             0,0,0,0,0,0,            0,0,0,0,        0,0,0,0,        0,0,    0,0,      0,    0,0,      0,0,      0,    0,0,      0,0);
var f3infi = new Array(2,3,4,0,     6,7,8,0,        10,11,12,13,14,0,  16,17,18,19,20,0,     22,23,24,25,26,27,28,29,30,31,32,33,34,35,0,   37,38,0,    40,41,42,43,0,          45,46,0,     48,49,50,51,52,53,54,55,56,57,58,59,60,61,0,               63,64,65,66,67,0,        69,70,71,72,73,0,        75,76,77,0,    79,80,81,0,     83,84,85,0,   87,88,89,0,    91,92,93,94,95,0,   97,98,99,100,101,0,   103,0,  105,106,107,108,0,  110,0,   112,113,114,115,116,0,   118,119,120,121,122,0,  124,125,126,0,  128,129,130,0,  132,0,  134,0,    0,    137,0,    139,0,    0,    142,0,    144,0);
var f4infi = new Array(0,0,0,0,     0,0,0,0,        0,0,0,0,0,0,       0,0,0,0,0,0,          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,                 0,0,0,      0,0,0,0,0,              0,0,0,       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,                             0,0,0,0,0,0,             0,0,0,0,0,0,             0,0,0,0,       0,0,0,0,        0,0,0,0,      0,0,0,0,       0,0,0,0,0,0,        0,0,0,0,0,0,          0,0,    0,0,0,0,0,          0,0,     0,0,0,0,0,0,             0,0,0,0,0,0,            0,0,0,0,        0,0,0,0,        0,0,    0,0,      0,    0,0,      0,0,      0,    0,0,      0,0);
var f5infi = new Array(0,0,0,0,     0,0,0,0,        0,82,83,84,85,0,   0,86,87,88,89,0,      0,90,91,92,93,94,95,0,96,97,98,99,100,101,0,   0,102,103,  104,105,106,107,108,    109,110,0,   0,111,112,113,114,115,116,0,117,118,119,120,121,122,0,     0,123,124,125,126,0,     0,127,128,129,130,0,     0,0,0,0,       0,0,0,0,        0,0,0,0,      0,0,0,0,       0,0,131,132,0,0,    0,0,133,134,0,0,      0,135,  136,137,0,138,139,  140,0,   0,0,141,142,0,0,         0,0,143,144,0,0,        0,0,0,0,        0,0,0,0,        0,0,    0,0,      0,    0,0,      0,0,      0,    0,0,      0,0);
var f6infi = new Array(0,0,0,0,     0,0,0,0,        0,0,0,0,0,0,       0,0,0,0,0,0,          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,                 0,0,0,      0,0,0,0,0,              0,0,0,       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,                             0,0,0,0,0,0,             0,0,0,0,0,0,             0,0,0,0,       0,0,0,0,        0,0,0,0,      0,0,0,0,       0,0,0,0,0,0,        0,0,0,0,0,0,          0,0,    0,0,0,0,0,          0,0,     0,0,0,0,0,0,             0,0,0,0,0,0,            0,0,0,0,        0,0,0,0,        0,0,    0,0,      0,    0,0,      0,0,      0,    0,0,      0,0);
var f7infi = new Array(0,0,0,0,     0,0,0,0,        0,0,0,0,0,0,       0,0,0,0,0,0,          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,                 0,0,0,      0,0,0,0,0,              0,0,0,       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,                             0,0,0,0,0,0,             0,0,0,0,0,0,             0,0,0,0,       0,0,0,0,        0,0,0,0,      0,0,0,0,       0,0,0,0,0,0,        0,0,0,0,0,0,          0,0,    0,0,0,0,0,          0,0,     0,0,0,0,0,0,             0,0,0,0,0,0,            0,0,0,0,        0,0,0,0,        0,0,    0,0,      0,    0,0,      0,0,      0,    0,0,      0,0);
var f8infi = new Array(0,0,0,0,     0,0,0,0,        0,0,0,0,0,0,       0,0,0,0,0,0,          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,                 0,0,0,      0,0,0,0,0,              0,0,0,       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,                             0,0,0,0,0,0,             0,0,0,0,0,0,             0,0,0,0,       0,0,0,0,        0,0,0,0,      0,0,0,0,       0,0,0,0,0,0,        0,0,0,0,0,0,          0,0,    0,0,0,0,0,          0,0,     0,0,0,0,0,0,             0,0,0,0,0,0,            0,0,0,0,        0,0,0,0,        0,0,    0,0,      0,    0,0,      0,0,      0,    0,0,      0,0);

var pxhouse = new Array(18,  8,10,12,14,16,18,20,   6,8,10,12,14,16,18,20,22,    4,6,8,10,12,14,16,18,20,22,24,      2,4,6,8,10,12,14,16,18,20,22,24,26,                    4,6,8,10,12,14,16,18,20,22,24,     4,6,8,10,12,14,16,      20,  24,  4,6,8,10,12,14,16,18,20,22,24,     18,   8,10,12,14,16,18,20,   6,8,10,12,14,16,18,20,22,   4,6,8,10,12,14,16,18,20,22,24,     2,4,6,8,10,12,14,16,18,20,22,24,26,                 4,6,8,10,12,        4,6,    10,12,   4,6,    10,12,   18,   8,   18,  6,8,10,     4,6,8,10,12,        2,4,6,8,10,12,14);
var pyhouse = new Array(0,   2,2,2,2,2,2,2,         4,4,4,4,4,4,4,4,4,           6,6,6,6,6,6,6,6,6,6,6,              8,8,8,8,8,8,8,8,8,8,8,8,8,                             10,10,10,10,10,10,10,10,10,10,10,  12,12,12,12,12,12,12,   12,  12,  14,14,14,14,14,14,14,14,14,14,14,  0,    2,2,2,2,2,2,2,         4,4,4,4,4,4,4,4,4,          6,6,6,6,6,6,6,6,6,6,6,             8,8,8,8,8,8,8,8,8,8,8,8,8,                          10,10,10,10,10,     12,12,  12,12,   14,14,  14,14,   0,    2,   2,   4,4,4,      6,6,6,6,6,          8,8,8,8,8,8,8);
var llhouse = new Array(0,   0,0,0,0,0,0,0,         0,0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,0,                             0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,          0,   0,   0,0,0,0,0,0,0,0,0,0,0,             1,    1,1,1,1,1,1,1,         1,1,1,1,1,1,1,1,1,          1,1,1,1,1,1,1,1,1,1,1,             1,1,1,1,1,1,1,1,1,1,1,1,1,                          1,1,1,1,1,          1,1,    1,1,     1,1,    1,1,     2,    2,   2,   2,2,2,      2,2,2,2,2,          2,2,2,2,2,2,2);
var f1house = new Array(0,   0,2,3,4,5,6,7,         0,9,10,11,12,13,14,15,16,    0,18,19,20,21,22,23,24,25,26,27,    0,29,30,31,32,33,34,35,36,37,38,39,40,                 0,42,43,44,45,46,47,48,49,50,51,   0,53,54,55,56,57,58,    0,   0,   0,62,63,64,65,66,67,68,69,70,71,   0,    0,74,75,76,77,78,79,   0,81,82,83,84,85,86,87,88,  0,90,91,92,93,94,95,96,97,98,99,   0,101,102,103,104,105,106,107,108,109,110,111,112,  0,114,115,116,117,  0,119,  0,121,   0,123,  0,125,   0,    0,   0,   0,130,131,  0,133,134,135,136,  0,138,139,140,141,142,143);
var f2house = new Array(0,   0,0,0,0,0,0,0,         0,0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,0,                             0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,          0,   0,   0,0,0,0,0,0,0,0,0,0,0,             0,    0,0,0,0,0,0,0,         0,0,0,0,0,0,0,0,0,          0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,0,0,0,0,0,0,                          0,0,0,0,0,          0,0,    0,0,     0,0,    0,0,     0,    0,   0,   0,0,0,      0,0,0,0,0,          0,0,0,0,0,0,0);
var f3house = new Array(0,   3,4,5,6,7,8,0,         10,11,12,13,14,15,16,17,0,   19,20,21,22,23,24,25,26,27,28,0,    30,31,32,33,34,35,36,37,38,39,40,41,0,                 43,44,45,46,47,48,49,50,51,52,0,   54,55,56,57,58,59,0,    0,   0,   63,64,65,66,67,68,69,70,71,72,0,   0,    75,76,77,78,79,80,0,   82,83,84,85,86,87,88,89,0,  91,92,93,94,95,96,97,98,99,100,0,  102,103,104,105,106,107,108,109,110,111,112,113,0,  115,116,117,118,0,  120,0,  122,0,   124,0,  126,0,   0,    0,   0,   131,132,0,  134,135,136,137,0,  139,140,141,142,143,144,0);
var f4house = new Array(0,   0,0,0,0,0,0,0,         0,0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,0,                             0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,          0,   0,   0,0,0,0,0,0,0,0,0,0,0,             0,    0,0,0,0,0,0,0,         0,0,0,0,0,0,0,0,0,          0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,0,0,0,0,0,0,                          0,0,0,0,0,          0,0,    0,0,     0,0,    0,0,     0,    0,   0,   0,0,0,      0,0,0,0,0,          0,0,0,0,0,0,0);
var f5house = new Array(73,  74,75,76,77,78,79,80,  81,82,83,84,85,86,87,88,89,  90,91,92,93,94,95,96,97,98,99,100,  101,102,103,104,105,106,107,108,109,110,111,112,113,   114,115,116,117,118,0,0,0,0,0,0,   119,120,0,121,122,0,0,  0,   0,   123,124,0,125,126,0,0,0,0,0,0,     127,  128,0,0,0,0,129,0,     130,131,132,0,0,0,0,0,0,    133,134,135,136,137,0,0,0,0,0,0,   138,139,140,141,142,143,144,0,0,0,0,0,0,            0,0,0,0,0,          0,0,    0,0,     0,0,    0,0,     0,    0,   0,   0,0,0,      0,0,0,0,0,          0,0,0,0,0,0,0);
var f6house = new Array(0,   0,0,0,0,0,0,0,         0,0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,0,                             0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,          0,   0,   0,0,0,0,0,0,0,0,0,0,0,             0,    0,0,0,0,0,0,0,         0,0,0,0,0,0,0,0,0,          0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,0,0,0,0,0,0,                          0,0,0,0,0,          0,0,    0,0,     0,0,    0,0,     0,    0,   0,   0,0,0,      0,0,0,0,0,          0,0,0,0,0,0,0);
var f7house = new Array(0,   0,0,0,0,0,0,0,         0,0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,0,                             0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,          0,   0,   0,0,0,0,0,0,0,0,0,0,0,             0,    0,0,0,0,0,0,0,         0,0,0,0,0,0,0,0,0,          0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,0,0,0,0,0,0,                          0,0,0,0,0,          0,0,    0,0,     0,0,    0,0,     0,    0,   0,   0,0,0,      0,0,0,0,0,          0,0,0,0,0,0,0);
var f8house = new Array(0,   0,0,0,0,0,0,0,         0,0,0,0,0,0,0,0,0,           0,0,0,0,0,0,0,0,0,0,0,              0,0,0,0,0,0,0,0,0,0,0,0,0,                             0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,          0,   0,   0,0,0,0,0,0,0,0,0,0,0,             0,    0,0,0,0,0,0,0,         0,0,0,0,0,0,0,0,0,          0,0,0,0,0,0,0,0,0,0,0,             0,0,0,0,0,0,0,0,0,0,0,0,0,                          0,0,0,0,0,          0,0,    0,0,     0,0,    0,0,     0,    0,   0,   0,0,0,      0,0,0,0,0,          0,0,0,0,0,0,0);

tN = new Array();   // nome dell immagine
tT = new Array();   // tipo della tessera (sui 36 possibili)
tS = new Array();   // stato
tX = new Array();   // coordinata x
tY = new Array();   // coordinata y
tL = new Array();   // livello
t1 = new Array();   // adiacenza sx 1
t2 = new Array();   // adiacenza sx 2
t3 = new Array();   // adiacenza dx 1
t4 = new Array();   // adiacenza dx 2
t5 = new Array();   // adiacenza sotto 1
t6 = new Array();   // adiacenza sotto 2
t7 = new Array();   // adiacenza sotto 3
t8 = new Array();   // adiacenza sotto 4
tMO = new Array();	// mouse over array
tMD = new Array();	// mouse down array
aP = new Array();   // array di salvataggio in caso di piccolo

startGame();

function prepareTiles()
{
	for(i = 0; i < 144; i++)
	{
		tN[i] = names[rando[i]];
		tT[i] = types[rando[i]];
		tMD[i] = 0;
		tMO[i] = 0;
		t1[i] = 0;
		t2[i] = 0;
		t3[i] = 0;
		t4[i] = 0;
		t5[i] = 0;
		t6[i] = 0;
		t7[i] = 0;
		t8[i] = 0;
	}

	switch(layoutName)
	{
		case 'Squares':
			baseX = 40;
			baseY = 15;
			for(i = 0; i < 144; i++)
			{
				tX[i] = baseX + (pxsquares[i] * halfX);
				tY[i] = baseY + (pysquares[i] * halfY);
				tL[i] = llsquares[i];
				t1[i] = f1squares[i];
				t2[i] = f2squares[i];
				t3[i] = f3squares[i];
				t4[i] = f4squares[i];
				t5[i] = f5squares[i];
				t6[i] = f6squares[i];
				t7[i] = f7squares[i];
				t8[i] = f7squares[i];
			}
			break;
		case 'Pyramid':
			baseX = 40;
			baseY = 20;
			for(i = 0; i < 144; i++)
			{
				tX[i] = baseX + (pxpyramid[i] * halfX);
				tY[i] = baseY + (pypyramid[i] * halfY);
				tL[i] = llpyramid[i];
				t1[i] = f1pyramid[i];
				t2[i] = f2pyramid[i];
				t3[i] = f3pyramid[i];
				t4[i] = f4pyramid[i];
				t5[i] = f5pyramid[i];
				t6[i] = f6pyramid[i];
				t7[i] = f7pyramid[i];
				t8[i] = f8pyramid[i];
			}
			break;
		case 'Castle':
			baseX = 40;
			baseY = 20;
			for(i = 0; i < 144; i++)
			{
				tX[i] = baseX + (pxcastle[i] * halfX);
				tY[i] = baseY + (pycastle[i] * halfY);
				tL[i] = llcastle[i];
				t1[i] = f1castle[i];
				t2[i] = f2castle[i];
				t3[i] = f3castle[i];
				t4[i] = f4castle[i];
				t5[i] = f5castle[i];
				t6[i] = f6castle[i];
				t7[i] = f7castle[i];
				t8[i] = f8castle[i];
			}
			break;
		case 'Omega':
			baseX = 40;
			baseY = 10;
			for(i = 0; i < 144; i++)
			{
				tX[i] = baseX + (pxomega[i] * halfX);
				tY[i] = baseY + (pyomega[i] * halfY);
				tL[i] = llomega[i];
				t1[i] = f1omega[i];
				t2[i] = f2omega[i];
				t3[i] = f3omega[i];
				t4[i] = f4omega[i];
				t5[i] = f5omega[i];
				t6[i] = f6omega[i];
				t7[i] = f7omega[i];
				t8[i] = f8omega[i];
			}
			break;
		case 'Towers':
			baseX = 40;
			baseY = 15;
			for(i = 0; i < 144; i++)
			{
				tX[i] = baseX + (pxtowers[i] * halfX);
				tY[i] = baseY + (pytowers[i] * halfY);
				tL[i] = lltowers[i];
				t1[i] = f1towers[i];
				t2[i] = f2towers[i];
				t3[i] = f3towers[i];
				t4[i] = f4towers[i];
				t5[i] = f5towers[i];
				t6[i] = f6towers[i];
				t7[i] = f7towers[i];
				t8[i] = f7towers[i];
			}
			break;
		default:
			baseX = 40;
			baseY = 10;
			for(i = 0; i < 144; i++)
			{
				tX[i] = baseX + (pxclassic[i] * halfX);
				tY[i] = baseY + (pyclassic[i] * halfY);
				tL[i] = llclassic[i];
				t1[i] = f1classic[i];
				t2[i] = f2classic[i];
				t3[i] = f3classic[i];
				t4[i] = f4classic[i];
				t5[i] = f5classic[i];
				t6[i] = f6classic[i];
				t7[i] = f7classic[i];
				t8[i] = f8classic[i];
			}
			break;
		case 'Infinite':
			baseX = 40;
			baseY = 20;
			for(i = 0; i < 144; i++)
			{
				tX[i] = baseX + (pxinfi[i] * halfX);
				tY[i] = baseY + (pyinfi[i] * halfY);
				tL[i] = llinfi[i];
				t1[i] = f1infi[i];
				t2[i] = f2infi[i];
				t3[i] = f3infi[i];
				t4[i] = f4infi[i];
				t5[i] = f5infi[i];
				t6[i] = f6infi[i];
				t7[i] = f7infi[i];
				t8[i] = f8infi[i];
			}
			break;
		case 'House':
			baseX = 40;
			baseY = 15;
			for(i = 0; i < 144; i++)
			{
				tX[i] = baseX + (pxhouse[i] * halfX);
				tY[i] = baseY + (pyhouse[i] * halfY);
				tL[i] = llhouse[i];
				t1[i] = f1house[i];
				t2[i] = f2house[i];
				t3[i] = f3house[i];
				t4[i] = f4house[i];
				t5[i] = f5house[i];
				t6[i] = f6house[i];
				t7[i] = f7house[i];
				t8[i] = f8house[i];
			}
			break;
	}

	for(i = 0; i < 144; i++)
	{
		tiles[i] = new Image();
		tiles[i].src = "Resources/Sets/"+setName+"/"+tN[i]+".png";
		tiles[i].hOffset = tX[i]-(tL[i] * delta);
		tiles[i].vOffset = tY[i]-(tL[i] * delta);
		tiles[i].zOrder = 10 + (i * 3);
		tiles[i].opacity = 255;
		tiles[i].onMouseUp = "handleMouseUp("+i+");";
		tiles[i].onMouseDown = "handleMouseDown("+i+");";
		tiles[i].onMouseExit = "handleMouseExit("+i+");";
		tiles[i].onMouseEnter = "handleMouseEnter("+i+");";
		aP[i] = 255;
	}
}

function prepareVars()
{
	gameMode = 0;
	gamePiccolo = 0;
	totalTiles = 144;
	points = 0;
	couples = 0;
	undoPenalty = 100;
	hintPenalty = 100;
	layoutName = preferences.layout.value;
	setName = preferences.set.value;
	timeGame = preferences.timegame.value;
	mappa.src = "Resources/Mappa.png";
	tiledown.src = "Resources/Sets/"+setName+"/down.png";
	tilesel.src = "Resources/Sets/"+setName+"/sel.png";
}

function zeroOpacity()
{
	bonusText.opacity = 0;
	bonusTextShadow.opacity = 0;
	bonusLabel.opacity = 0;
	bonusLabelShadow.opacity = 0;
	scoreText.opacity = 0;
	scoreTextShadow.opacity = 0;
	scoreLabel.opacity = 0;
	scoreTextShadow.opacity = 0;
	hiScoreText.opacity = 0;
	hiScoreTextShadow.opacity = 0;
	hiScoreLabel.opacity = 0;
	hiScoreTextShadow.opacity = 0;
}

function fullOpacity()
{
	gameText.opacity = 255;
	gameTextShadow.opacity = 255;
	leftText.opacity = 255;
	leftTextShadow.opacity = 255;
	leftLabel.opacity = 255;
	leftLabelShadow.opacity = 255;
}

function startPlay()
{
	prepareVars();
	if(timeGame == 1)
	{
		bonusText.opacity = 255;
		bonusTextShadow.opacity = 255;
		bonusLabel.opacity = 255;
		bonusLabelShadow.opacity = 255;
		scoreText.opacity = 255;
		scoreTextShadow.opacity = 255;
		scoreLabel.opacity = 255;
		scoreLabelShadow.opacity = 255;
		switch(layoutName)
		{
			case "Classic":
				setHiScore(hiScoreClassic);
				break;
			case "Castle":
				setHiScore(hiScoreCastle);
				break;
			case "Pyramid":
				setHiScore(hiScorePyramid);
				break;
			case "Squares":
				setHiScore(hiScoreSquares);
				break;
			case "Omega":
				setHiScore(hiScoreOmega);
				break;
			case "Towers":
				setHiScore(hiScoreTowers);
				break;
			case "Infinite":
				setHiScore(hiScoreInfinite);
				break;
			case "House":
				setHiScore(hiScoreHouse);
				break;
		}
		hiScoreText.opacity = 255;
		hiScoreTextShadow.opacity = 255;
		hiScoreLabel.opacity = 255;
		hiScoreLabelShadow.opacity = 255;
		setGame("Time"+gameString);
		bonus = 510;
	}
	else
	{
		zeroOpacity();
		setGame("Standard"+gameString);
		bonus = 0;
	}
	fullOpacity();
	setLeft();
	setPoints();
	shuffle();
	prepareTiles();
	resetUndo();
	gameStopped = 0;
	updateNow();
}

function startGame()
{
	prepareVars();
	zeroOpacity();
	setGame("Press S to start");
	bonus = 0;
	fullOpacity();
	setLeft();
	setPoints();
	shuffle();
	prepareTiles();
	resetUndo();
	gameStopped = 1;
}

function shuffle()
{
	for(i = 0; i < 144; i++)
	{
		r = parseInt(Math.random() * (i + 1));
		rando[i] = rando[r];
		rando[r] = i;
	}
}

function checkFreedom(p)
{
	var retS = 1;
	var retD = 1;
	var retV = 1;	
	
	if(t1[p] > 0)
	{
		if(tiles[t1[p] - 1].opacity > 0)
		{
			retS = 0;
		}
	}
	if(t2[p] > 0)
	{
		if(tiles[t2[p] - 1].opacity > 0)
		{
			retS = 0;
		}
	}
	if(t3[p] > 0)
	{
		if(tiles[t3[p] - 1].opacity > 0)
		{
			retD = 0;
		}
	}
	if(t4[p] > 0)
	{
		if(tiles[t4[p] - 1].opacity > 0)
		{
			retD = 0;
		}
	}
	if(t5[p] > 0)
	{
		if(tiles[t5[p] - 1].opacity > 0)
		{
			retV = 0;
		}
	}
	if(t6[p] > 0)
	{
		if(tiles[t6[p] - 1].opacity > 0)
		{
			retV = 0;
		}
	}
	if(t7[p] > 0)
	{
		if(tiles[t7[p] - 1].opacity > 0)
		{
			retV = 0;
		}
	}
	if(t8[p] > 0)
	{
		if(tiles[t8[p] - 1].opacity > 0)
		{
			retV = 0;
		}
	}
	return(((retS > 0) || (retD > 0)) && (retV > 0));
}

function handleMouseDown(p)
{
	if(checkFreedom(p))
	{
		tMD[p] = 1;
		tMO[p] = 1;
		setDown(p);
	}
}

function handleMouseEnter(p)
{
	if(checkFreedom(p))
	{
		tMO[p] = 1;
		if(tMD[p] > 0)
		{
			setDown(p);
		}
	}
}

function handleMouseExit(p)
{
	tMO[p] = 0;
	resetDown();
}

function handleMouseUp(p)
{
	if(checkFreedom(p))
	{
		tMD[p] = 0;
		resetDown();
		if(tMO[p] == 1)
		{
			checkClick(p);
		}
	}
}

function setDown(p)
{
	tiledown.opacity = 255;
	tiledown.hOffset = tiles[p].hOffset;
	tiledown.vOffset = tiles[p].vOffset;
	tiledown.zOrder = 14 + (p * 3);
}

function resetDown()
{
	tiledown.opacity = 0;
	tiledown.zOrder = 0;
}

function setSel(p)
{
	tilesel.opacity = 255;
	tilesel.hOffset = tiles[p].hOffset;
	tilesel.vOffset = tiles[p].vOffset;
	tilesel.zOrder = 13 + (p * 3);
}

function resetSel()
{
	tilesel.opacity = 0;
	tilesel.zOrder = 0;
}

function setHint1(p)
{
	tilehint1.opacity = 255;
	tilehint1.hOffset = tiles[p].hOffset;
	tilehint1.vOffset = tiles[p].vOffset;
	tilehint1.zOrder = 12 + (p * 3);
}

function resetHint1()
{
	tilehint1.opacity = 0;
	tilehint1.zOrder = 0;
}

function setHint2(p)
{
	tilehint2.opacity = 255;
	tilehint2.hOffset = tiles[p].hOffset;
	tilehint2.vOffset = tiles[p].vOffset;
	tilehint2.zOrder = 11 + (p * 3);
}

function resetHint2()
{
	tilehint2.opacity = 0;
	tilehint2.zOrder = 0;
}

function checkClick(p)
{
	if(p != (tileSelected - 1))
	{
		if(gameMode == 0)
		{
			gameMode = 1;
			typeSelected = tT[p];
			tileSelected = p+1;
			setSel(p);
		}
		else
		{
			if(tT[p] == typeSelected)
			{
				removeTiles(tileSelected - 1,p);
			}
			gameMode = 0;
			tileSelected = 0;
			typeSelected = 0;
			resetSel();
		}
	}
	else
	{
		gameMode = 0;
		tileSelected = 0;
		typeSelected = 0;
		resetSel();
	}
}

function removeTiles(a,b)
{
	tiles[a].opacity = 0;
	tiles[b].opacity = 0;
	undoOne[undoPointer] = a;
	undoTwo[undoPointer] = b;
	undoPointer++;
	totalTiles -= 2;
	setLeft();
	choPlay("ding.aif");
	if(timeGame == 1)
	{
		points += bonus;
		setPoints();
		bonus = 510;
	}
	if(totalTiles < 1)
	{
		gameOver();
	}
	else
	{
		checkCouples();
		if(couples == 0) gameOverFailed();
	}
}

function choPlay(s)
{
	if(preferences.sound.value == 1) play(s);
}

function checkCouples()
{
	couples = 0;
	hints = 0;
	resetHint1();
	resetHint2();
	for(i = 1; i < 37; i++)
	{
		accop[i] = 0;
		hintList[i] = new Array(-1,-1,-1,-1);
		hintArray[i] = 0;
	}
	for(i = 0; i < 144; i++)
	{
		if(tiles[i].opacity > 0)
		{
			if(checkFreedom(i))
			{
				accop[tT[i]] += 1;
				if(hintList[tT[i]][0] == -1) hintList[tT[i]][0] = i;
				else
				{
					hints++;
					hintArray[hints] = tT[i];
					if(hintList[tT[i]][1] == -1) hintList[tT[i]][1] = i;
					else
					{
						if(hintList[tT[i]][2] == -1) hintList[tT[i]][2] = i;
						else if(hintList[tT[i]][3] == -1) hintList[tT[i]][3] = i;
					}
				}
			}
		}
	}
	for(i = 1; i < 37; i++)
	{
		switch(accop[i])
		{
			case 2:
			case 3:
				couples++;
				break;
			case 4:
				couples += 2;
				break;
		}
	}
}

function gameOverFailed()
{
	tilesel.opacity = 0;
	tiledown.opacity = 0;
	gameStopped = 1;
	choPlay("over.aif");
	askReplay();
	gameOverFactorB();
}

function gameOverFactorA(h,p,l)
{
	savePreferences();
	setHiScore(points);
	if(h > 25000)
	{
		if(parseInt(preferences.regPref.value) > 0) sendRecord(layoutName,h);
	}
	gameOverFactorB();
}

function gameOverFactorB()
{
	setGame("Game Over");
	sleep(1000);
	setGame("Hit S to play");
}

function askReplay()
{
	var s = "";
	if(totalTiles == 0) s = "Congratulations! ";
	var a = alert(s+"Do you want to see the replay of this game?","No","Yes");
	if(a == 2)
	{
		doReplay();
	}
}

function doReplay()
{
	for(i = 0; i < 144;i++)
	{
		tiles[i].opacity = 255;
	}
	var fine = 72 - Math.floor(totalTiles/2);
	for(i = 0;i < fine;i++)
	{
		sleep(800);
		tiles[undoOne[i]].opacity = 0;
		tiles[undoTwo[i]].opacity = 0;
		updateNow();
		choPlay("ding.aif");
	}
}

function gameOver()
{
	gameStopped = 1;
	choPlay("over.aif");
	askReplay();
	switch(layoutName)
	{
		case "Classic":
			if(points > hiScoreClassic)
			{
				hiScoreClassic = points;
				preferences.hiScoreClassicPref.value = points;
				gameOverFactorA(hiScoreClassic);
			}
			else
			{
				gameOverFactorB();
			}
			break;
		case "Castle":
			if(points > hiScoreCastle)
			{
				hiScoreCastle = points;
				preferences.hiScoreCastlePref.value = points;
				gameOverFactorA(HiScoreCastle);
			}
			else
			{
				gameOverFactorB();
			}
			break;
		case "Pyramid":
			if(points > hiScorePyramid)
			{
				hiScorePyramid = points;
				preferences.hiScorePyramidPref.value = points;
				gameOverFactorA(hiScorePyramid);
			}
			else
			{
				gameOverFactorB();
			}
			break;
		case "Squares":
			if(points > hiScoreSquares)
			{
				hiScoreSquares = points;
				preferences.hiScoreSquaresPref.value = points;
				gameOverFactorA(hiScoreSquares);
			}
			else
			{
				gameOverFactorB();
			}
			break;
		case "Omega":
			if(points > hiScoreOmega)
			{
				hiScoreOmega = points;
				preferences.hiScoreOmegaPref.value = points;
				gameOverFactorA(hiScoreOmega);
			}
			else
			{
				gameOverFactorB();
			}
			break;
		case "Towers":
			if(points > hiScoreTowers)
			{
				hiScoreTowers = points;
				preferences.hiScoreTowersPref.value = points;
				gameOverFactorA(hiScoreTowers);
			}
			else
			{
				gameOverFactorB();
			}
			break;
		case "Infinite":
			if(points > hiScoreInfinite)
			{
				hiScoreInfinite = points;
				preferences.hiScoreInfinitePref.value = points;
				gameOverFactorA(hiScoreInfinite);
			}
			else
			{
				gameOverFactorB();
			}
			break;
		case "House":
			if(points > hiScoreHouse)
			{
				hiScoreHouse = points;
				preferences.hiScoreHousePref.value = points;
				gameOverFactorA(hiScoreHouse);
			}
			else
			{
				gameOverFactorB();
			}
			break;
	}
}

function resetUndo()
{
	for(i = 0;i < 72;i++)
	{
		undoOne[i] = 0;
		undoTwo[i] = 0;
	}
	undoPointer = 0;
	//undoPenalty = 100;
}

function annulla()
{
	if(gamePiccolo == 0)
	{
		if(undoPointer > 0)
		{
			if(timeGame != 1) doUndo();
			else
			{
				if(points >= undoPenalty)
				{
					doUndo();
				}
			}
		}
	}
}

function doUndo()
{
	undoPointer--;
	tiles[undoOne[undoPointer]].opacity = 255;
	tiles[undoTwo[undoPointer]].opacity = 255;
	points -= undoPenalty;
	undoPenalty = undoPenalty * 2;
	totalTiles += 2;
	gameMode = 0;
	bonus = 510;
	tileSelected = 0;
	typeSelected = 0;
	resetSel();
	setLeft();
	setPoints();
	updateNow();
}

function suggerisci()
{
	if(gamePiccolo == 0)
	{
		if(timeGame != 1) doHint();
		else
		{
			if(points >= hintPenalty)
			{
				doHint();
			}
		}
	}
}

function doHint()
{
	var r1 = random(1,(hints + 1));
	var r2 = 0;
	if(hintList[hintArray[r1]][3] > -1) r2 = random(1,4);
	else
	{
		if(hintList[hintArray[r1]][2] > -1) r2 = random(1,3);
		else r2 = 1;
	}
	//print("====HINT====");
	//print("hints: " + hints);
	//print("r1: " + r1);
	//print("r2: " + r2);
	//print("<<hintArray>>");
	//for(i = 1; i < 37; i++)
	//{
	//	print(i + ": " + hintArray[i]);
	//}
	//print("<<hintList>>");
	//for(i = 1; i < 37; i++)
	//{
	//	print(i + ": " + hintList[i][0] + ":"  + hintList[i][1] + ":"  + hintList[i][2] + ":"  + hintList[i][3]);
	//}
	setHint1(hintList[hintArray[r1]][0]);
	setHint2(hintList[hintArray[r1]][r2]);
	points -= hintPenalty;
	hintPenalty = hintPenalty * 2;
	setPoints();
	updateNow();
}

function onTimer()
{
	if(gameStopped == 0)
	{
		if(timeGame == 1)
		{
			if(gamePiccolo == 0)
			{
				if(bonus > 0)
				{
					bonus -= 10;
					setBonus();
					updateNow();
				}
			}
		}
	}
}

function setBonus()
{
	bonusTextShadow.data = bonus;
	bonusText.data = bonus;
}

function setPoints()
{
	scoreTextShadow.data = points;
	scoreText.data = points;
}

function setGame(s)
{
	gameText.data = s;
	gameTextShadow.data = s;
}

function setLeft()
{
	leftText.data = totalTiles;
	leftTextShadow.data = totalTiles;
}

function setHiScore(p)
{
	hiScoreText.data = p;
	hiScoreTextShadow.data = p;
}

function resetHiScore()
{
	var a = alert("Do you really want to reset the high score?","Ok","Cancel");
	if(a == 1)
	{
		hiScoreClassic = 0;
		hiScoreCastle = 0;
		hiScorePyramid = 0;
		hiScoreSquares = 0;
		hiScoreOmega = 0;
		hiScoreTowers = 0;
		hiScoreInfinite = 0;
		hiScoreHouse = 0;
		setHiScore(0);
		preferences.hiScoreClassicPref.value = 0;
		preferences.hiScoreCastlePref.value = 0;
		preferences.hiScorePyramidPref.value = 0;
		preferences.hiScoreSquaresPref.value = 0;
		preferences.hiScoreOmegaPref.value = 0;
		preferences.hiScoreTowersPref.value = 0;
		preferences.hiScoreInfinitePref.value = 0;
		preferences.hiScoreHousePref.value = 0;
		savePreferences();
	}
}

function switchPiccolo()
{
	if(gamePiccolo == 0)
	{
		gamePiccolo = 1;
		mappa.opacity = 0;
		bonusText.opacity = 0;
		bonusTextShadow.opacity = 0;
		bonusLabel.opacity = 0;
		bonusLabelShadow.opacity = 0;
		scoreText.opacity = 0;
		scoreTextShadow.opacity = 0;
		scoreLabel.opacity = 0;
		scoreLabelShadow.opacity = 0;
		hiScoreText.opacity = 0;
		hiScoreTextShadow.opacity = 0;
		hiScoreLabel.opacity = 0;
		hiScoreLabelShadow.opacity = 0;
		gameText.opacity = 0;
		gameTextShadow.opacity = 0;
		leftText.opacity = 0;
		leftTextShadow.opacity = 0;
		leftLabel.opacity = 0;
		leftLabelShadow.opacity = 0;
		piccolo.opacity = 255;
		for(i = 0; i < 144; i++)
		{
			aP[i] = tiles[i].opacity;
			tiles[i].opacity = 0;
		}
		//if(system.platform != "windows")
		//{
			mi[0].enabled = false;
			mi[1].title = "Show";
		//}
	}
	else
	{
		gamePiccolo = 0;
		mappa.opacity = 255;
		if(timeGame == 1)
		{
			bonusText.opacity = 255;
			bonusTextShadow.opacity = 255;
			bonusLabel.opacity = 255;
			bonusLabelShadow.opacity = 255;
			scoreText.opacity = 255;
			scoreTextShadow.opacity = 255;
			scoreLabel.opacity = 255;
			scoreLabelShadow.opacity = 255;
			hiScoreText.opacity = 255;
			hiScoreTextShadow.opacity = 255;
			hiScoreLabel.opacity = 255;
			hiScoreLabelShadow.opacity = 255;
		}
		gameText.opacity = 255;
		gameTextShadow.opacity = 255;
		leftText.opacity = 255;
		leftTextShadow.opacity = 255;
		leftLabel.opacity = 255;
		leftLabelShadow.opacity = 255;
		piccolo.opacity = 0;
		for(i = 0; i < 144; i++)
		{
			tiles[i].opacity = aP[i];
		}
		//if(system.platform != "windows")
		//{
			mi[0].enabled = true;
			mi[1].title = "Hide";
		//}
	}
	updateNow();
}

function doLose()
{
	piccolo.src = "Resources/inerte.png";
}

function doGain()
{
	piccolo.src = "Resources/piccolo.png";
}

function onKeyDown()
{
	var keyCode = String.fromCharCode(system.event.keyString);
	if(gameStopped == 1)
	{
		if(keyCode.indexOf("s") != -1) startPlay();
		if(keyCode.indexOf("S") != -1) startPlay();
		if(keyCode.indexOf("b") != -1) switchPiccolo();
		if(keyCode.indexOf("B") != -1) switchPiccolo();
		if(keyCode.indexOf("r") != -1) resetHiScore();
		if(keyCode.indexOf("R") != -1) resetHiScore();
	}
	else
	{
		if(keyCode.indexOf("s") != -1) askToStartPlay();
		if(keyCode.indexOf("S") != -1) askToStartPlay();
		if(keyCode.indexOf("b") != -1) switchPiccolo();
		if(keyCode.indexOf("B") != -1) switchPiccolo();
		if(keyCode.indexOf("u") != -1) annulla();
		if(keyCode.indexOf("U") != -1) annulla();
		if(keyCode.indexOf("h") != -1) suggerisci();
		if(keyCode.indexOf("H") != -1) suggerisci();
	}
	return false;
}

function conditionalStartPlay()
{
	if(gameStopped == 1) startPlay();
	else askToStartPlay();
}

function askToStartPlay()
{
	if(gamePiccolo == 0)
	{
		var a = alert("Do you really want to reshuffle all tiles and start a new game?","Yes","No");
		if(a == 1) startPlay();
	}
}

function sendRecord(s,p)
{
	if(preferences.id.value == 0)
	{
		var ff = new Array();
		ff[0] = new FormField();
		ff[0].name = "ff_nick";
		ff[0].type = "text";
		ff[0].title = "Nickname:";
		ff[0].minLength = 3;
		ff[0].maxLength = 20;
		ff[0].description = "Please enter a nickname from 3 to 20 characters.";		
		var n = form(ff,"Nickname","Ok","Cancel");
		if(!n) return;
		else
		{
			while((n[0].length < 3)||(n[0].length > 21))
			{
				n = form(ff,"Nickname","Ok","Cancel");
				if(!n) return;
			}
			preferences.nick.value = n[0];
			savePreferences();
		}
	}
	var u = new URL();
	var dbn = "";
	switch(s)
	{
		case "Classic":
			dbn = "reg_njclassic";
			break;
		case "Castle":
			dbn = "reg_njcastle";
			break;
		case "Pyramid":
			dbn = "reg_njpyramid";
			break;
		case "Squares":
			dbn = "reg_njsquares";
			break;
		case "Omega":
			dbn = "reg_njomega";
			break;
		case "Towers":
			dbn = "reg_njtowers";
			break;
		case "Infinite":
			dbn = "reg_njinfinite";
			break;
		case "House":
			dbn = "reg_njhouse";
			break;
	}
	var l = "http://www.redomegastudio.com/comune/" + dbn + ".php?id="+preferences.id.value+"&nn="+preferences.nick.value+"&pp="+p+"&ll=0"; // questo sara quello vero
	var c = u.fetch(l);
	var w = c.split(',');
	if(w[0] != 0)
	{
		alert(w[1]);
	}
	else
	{
		preferences.id.value = w[1];
		var a = alert("Your score has been written on our database!","Ok","Visit the website");
		if(a == 2)
		{
			openURL("http://www.redomegastudio.com/eng/nujongg.php");
		}
	}
}

main_window.visible = true;
suppressUpdates();
focusWidget();